#pragma once

#ifndef uint8
#define uint8  unsigned char
#endif

#ifndef uint32
#define uint32 unsigned long int
#endif

class CCryptAES
{
	public:
		CCryptAES();
		BOOL decodeBuffer(uint8 *buffer, int lenBuffer);
		BOOL encodeBuffer(uint8 *buffer, int lenBuffer);

	private:
		uint32 erk[64];     /* encryption round keys */
		uint32 drk[64];     /* decryption round keys */
		int nr;             /* number of rounds */

		int  aes_set_key(uint8 *key, int nbits );
		void aes_set_key_eoa();
		void aes_encrypt(uint8 input[16], uint8 output[16] );
		void aes_decrypt(uint8 input[16], uint8 output[16] );
		void aes_gen_tables( void );
};



